<?

use Joomla\CMS\Factory;

class Sber_id_component {
	
	private $oauth_handler;
	private $app;
	/* OAUTH, BASE_AUTH */
	private $mode = 'OAUTH';
	private $oauth_status = false;
	private $test_mode = false;
	private $joomla_sql_user = false;
	private $sber_sql_user = false;
	
	private $request_data = array(
		'code' => false,
	);

	private $options = array(
		'client_id' => false,
		'client_secret' => false,
		'sert_password' => false,
		'pkce' => false,
		'scopes' => false,
		'sert_dir' => '',
		'log_dir' => '',
		'api_version' => 'v5',
		'api_mode' => 'TEST'
	);
	private $login_form_data = array(
		'username' => false,
		'email' => false,
		'password' => false,
		'auth_error' => false,
		'sitename' => false,
	);
	private $session_data;

	public function __construct($app,$api_version = 'v5',$api_mode = 'TEST') {
		$this->app = $app;
		require_once JPATH_BASE . '/plugins/authentication/sber_id/lib/handler.php';
		$this->oauth_handler = new Sberbank\Auth\Handler($api_version, $api_mode);
		
	}
	function set_options($arr) {
		$this->options = $arr;	
	}
	function set_request_data($arr) {
		$this->request_data = $arr;	
	}
	

	function start_auth() {
		$this->before_oauth_checks();
		if($this->mode === 'OAUTH') {
			$this->init_oauth_handler();
			$this->after_oauth_checks();
		} else if($this->mode === 'BASE_AUTH') {
			$this->show_template_login();
		} else if($this->mode === 'FINISH_LOGIN') {
			$joomla_user_finded = $this->find_user_joomla_table('email', $this->session_data['email']);
			$this->create_user_sber_table($joomla_user_finded->id, $this->session_data['sberid_user']);
			$this->app->redirect(JRoute::_('/', false));
		}
	}

	function init_oauth_handler() {
		if($this->test_mode) {
			$this->oauth_status = true;
			return false;
		}

		// debug Enable
		// $this->oauth_handler->debugOn();

		// set options
		$this->oauth_handler->setClientId($this->options['client_id']);
		$this->oauth_handler->setClientSecret($this->options['client_secret']);
		$this->oauth_handler->setSertificateDir($this->options['sert_dir']);
		$this->oauth_handler->setLogDir($this->options['log_dir']);
		$this->oauth_handler->setSertificatePassword($this->options['sert_password']);

		$session = JFactory::getSession();
		if($this->options['pkce'] == 1) {
			$this->oauth_handler->setProperty('pkce', $this->options['pkce'] == 1 ? true : false);
			$this->oauth_handler->setProperty('code_verifier', ($session->get('sberid_code_verifier') ? $session->get('sberid_code_verifier') : false));
		}
		$session->clear('sberid_code_verifier'); 

		$this->oauth_handler->setProperty( 'code', $this->request_data['code'] );

		// requests to API
		$this->oauth_handler->reqGetAccessToken();
		$this->oauth_handler->reqGetUserInfo();

		$this->oauth_status = $this->oauth_handler->authSuccess();
	}

	function find_user_joomla_table($type,$value) {

		if($type === 'email') {
			$db = JFactory::getDbo();
			$query = $db->getQuery(true)
			    ->select($db->quoteName('id'))
			    ->from($db->quoteName('#__users'))
			    ->where($db->quoteName('email') . ' = ' . $db->quote($value));
			$db->setQuery($query);

			if (!$id = $db->loadResult())
			{
				return false;
			}
		} else if($type === 'id') {
			$id = $value;
		}

		$user = JFactory::getUser($id);
		if($user->id) {
			return $user;
		} else {
			return false;
		}
	}

	function find_user_sber_table($data) {
		$result;

	    $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select($db->quoteName(array('user_id', 'email', 'phone','sub','aud','linked_account_id')));
        $query->from($db->quoteName('#__sber_id_users'));
        $query->where($db->quoteName('sub') . ' = ' . $db->quote($data['sub']));
        $db->setQuery($query);
        
        $result = $db->loadObjectList();

        if($result) {
        	return $result[0];
        } else {
			return false;
        }
	}
	function create_user_sber_table($joomla_user_id,$sber_id_user) {
		$result;
		JTable::addIncludePath(JPATH_COMPONENT . '/tables');
		$Sberbank_user = JTable::getInstance('sber_id_users', 'SberidTable');

		$Sberbank_user->linked_account_id = $joomla_user_id;
		$Sberbank_user->name = $sber_id_user['family_name'] . ' ' . $sber_id_user['given_name'] . ' '. $sber_id_user['middle_name'];
		$Sberbank_user->email = $sber_id_user['email'];
		$Sberbank_user->phone = $sber_id_user['phone'];
		$Sberbank_user->aud = $sber_id_user['aud'];
		$Sberbank_user->sub = $sber_id_user['sub'];
		
		$result = $Sberbank_user->store();
		return $result;
	}

	function update_user_sber_table($sber_id_user, $joomla_user_id) {
		$result;
		$sberid_user = new stdClass();
		$sberid_user->user_id = $sber_id_user->user_id;
		$sberid_user->linked_account_id = $joomla_user_id->id;
		$result = JFactory::getDbo()->updateObject('#__sber_id_users', $sberid_user, 'user_id');
		return $result;
	}

	function create_user_joomla_table($data) {
		$password = $this->generatePassword($data['sub']);

		$user_data = array(
		    'name'=> $data['family_name'] . ' ' . $data['given_name'] . ' ' . $data['middle_name'],
		    'username'=> "sberid" . substr($data['sub'], 0,6),
		    'password'=> $password,
		    'email'=> $data['email'],
		    'groups'=>array(2), // set the usergroup(s) here (id)
		);

		$user = new JUser;
		$user->bind($user_data);
		$user->save();
		$result = $this->find_user_joomla_table('email',$user_data['email']);

		return $result;
	}




	function before_oauth_checks() {
		$session = JFactory::getSession();

		// if($this->request_data['return_main']) {
		// 	$session->clear('sberid_user');
		// 	$this->app->redirect(JRoute::_('/', false));
		// 	return false;
		// }
		if($this->request_data['login']) {

			$session_user = $session->get('sberid_user');
			if($session_user) {
				$this->session_data = $session_user;
			} else {
				$this->session_data = false;
			}

			if($this->request_data['username']) {
				if($this->user_auth($this->request_data['username'], $this->request_data['password'])) {
					$this->mode = 'FINISH_LOGIN';
					$session->clear('sberid_user');
					return true;
				} else {
					$this->login_form_data['auth_error'] = true;
				}
			}
			$this->mode = 'BASE_AUTH';

		} else {
			$this->mode = 'OAUTH';
		}
	}

	function after_oauth_checks() {
		if($this->oauth_status) {
			$this->sber_id_user = $this->oauth_handler->getUserinfo();

			$sber_user_finded = $this->find_user_sber_table($this->sber_id_user);
			$type=false;

			if($sber_user_finded) {
				$joomla_user_finded = $this->find_user_joomla_table('id', $sber_user_finded->linked_account_id);
				if($joomla_user_finded) {
					$type = 1; // Auth, users finded and already created
				} else {
					$type = 2; // Update sberid user and create new joomla user and auth
					$joomla_user_finded = $this->create_user_joomla_table($this->sber_id_user);
					$this->update_user_sber_table($sber_user_finded, $joomla_user_finded);
				}
			} else {
				if($joomla_user_finded = $this->find_user_joomla_table('email', $this->sber_id_user['email'])) {
					$type = 3; // Need login in joomla, show login form
				} else {
					$type = 4; // Create sberid and joomla users, and auth
					$joomla_user_finded = $this->create_user_joomla_table($this->sber_id_user);
					$this->create_user_sber_table($joomla_user_finded->id, $this->sber_id_user);
				}
			}
			if($type == 1 || $type == 2 || $type == 4) {
				$this->finish_auth($joomla_user_finded);
			} else if($type == 3) {

				$form_data = array(
					'email' => $joomla_user_finded->email,
					'username' => $joomla_user_finded->username,
					'password' => $joomla_user_finded->password,
					'sberid_user' => $this->sber_id_user,
				);
				$session = JFactory::getSession();
				$session->set('sberid_user', $form_data);

				$this->app->redirect(JRoute::_('index.php?option=com_sberid&login=1', false));
				$this->show_template_login($template_options);
			}
			
		} else {
			$this->show_template_error();
		}
	}

	function finish_auth($user_data) {
		$password = $this->generatePassword($this->sber_id_user['sub']);
		$options = array(
            // 'silent' => false,
            // 'remember' => $this->config->get('remember_user',1)
        );
		
		if($this->user_auth($user_data->username, $password, $options)) {
			$session = JFactory::getSession();
			$session->clear('sberid_user');
			$this->oauth_handler->reqComplete();
			$this->app->redirect(JRoute::_('/', false));
		} else {
			return false;
		}
	}

	private function user_auth($username, $password, $options = array()) {
		return $this->app->login( array( 'username'=> $username,'password'=> $password), $options );
	}
	function show_template_error() {
		// show result and logging
		$this->oauth_handler->logger();
		$this->oauth_handler->showError();
	}
	function show_template_login() {
		$data = array(
			'email' => $this->session_data['email'],
			'username' => $this->session_data['username'],
			'fullname' => $this->session_data['sberid_user']['given_name'] . ' ' . $this->session_data['sberid_user']['middle_name'],
			'sitename' => $this->app->get('sitename'),
			'auth_error' => $this->login_form_data['auth_error'],
		);
		$data['entry__page_title'] = 'Sberbank ID Авторизация';
		$data['entry_title'] = 'Вы успешно вошли по Сбер ID.<br>Мы нашли вашу учетную запись на сайте<br>';
		$data['entry_footer'] = 'Вы можете привязать ee к аккаунту Сбер ID. Для этого подтвердите эту учетную запись <b>паролем</b>';
		$data['entry_password_error'] = 'Ошибка, поле пароль заполнено неверно!';
		$data['entry_text_auth'] = 'Авторизоваться';
		$data['entry_text_return'] = 'Вернуться на сайт';
		require_once JPATH_BASE . '/components/com_sberid/view/default.php';
	}
	function test_mode_enabled() {
		$this->test_mode = true;
		$this->oauth_handler->test_mode_enabled();
	}
	private function generatePassword($value) {
		$salt = '2fdsF-23r2-5432';
		return md5($salt.$value);
	}
}

$app = JFactory::getApplication();

/* Check plugin */
$plugin = JPluginHelper::getPlugin('authentication','sber_id');

if(!$plugin) {
	return false;
}


/* set $options params */

$pluginParams = new JRegistry($plugin->params);
$pluginParams = $pluginParams->toArray();

$options = array(
    'client_id' => $pluginParams['API_MODE'] == 'TEST' ? $pluginParams['TEST_CLIENT_ID'] : $pluginParams['CLIENT_ID'],
    'client_secret' => $pluginParams['API_MODE'] == 'TEST' ?  $pluginParams['TEST_CLIENT_SECRET'] : $pluginParams['CLIENT_SECRET'],
    'sert_password' => $pluginParams['API_MODE'] == 'TEST' ? $pluginParams['TEST_SERTIFICATE_PASSWORD'] : $pluginParams['SERTIFICATE_PASSWORD'],
    'pkce' => $pluginParams['USE_PKCE'],
    'scopes' => isset($pluginParams['SCOPES']) ? $pluginParams['SCOPES'] : array(),
    'api_version' => $pluginParams['API_VERSION'],
    'sert_dir' => JPATH_BASE . '/plugins/authentication/sber_id/sert/',
    'log_dir' => JPATH_BASE . '/plugins/authentication/sber_id/log/',
    'api_mode' => $pluginParams['API_MODE']
);


/* set $request_data params */

$input = Factory::getApplication()->input;
$request_data = Array(
	'code' => $input->get('code', false),
	'error' => $input->get('error', false),
	'state' => $input->get('state', false),
	'login' => $input->get('login', false),
	'username' => $input->get('username', false),
	'password' => $input->get('password', ''),
	'email' => $input->get('email', ''),
	'return_main' => $input->get('return_main', false)
);

/* init Component */

$sber_id_component = new Sber_id_component($app,$options['api_version'], $options['api_mode']);

// $sber_id_component->test_mode_enabled();

$sber_id_component->set_options($options);
$sber_id_component->set_request_data($request_data);
$sber_id_component->start_auth();
die;

?>