<?php


// No direct access.
defined('_JEXEC') or die('(@)|(@)');

require_once JPATH_BASE.'/modules/mod_login/helper.php';
require_once dirname(__FILE__).'/helper.php';

if(file_exists(JPATH_BASE . '/plugins/authentication/sber_id/lib/handler.php')) {
  require_once JPATH_BASE . '/plugins/authentication/sber_id/lib/handler.php';
}

$user = JFactory::getUser();
$plugin = JPluginHelper::getPlugin('authentication','sber_id');
$session = JFactory::getSession();

if($plugin && JPluginHelper::isEnabled('authentication','sber_id') && $user->id == 0) {
  
  $session->clear('sberid_user');
  $session->clear('sberid_code_verifier');
  
  

  $pluginParams = new JRegistry($plugin->params);
  $pluginParams = $pluginParams->toArray();

  $options = array(
    'client_id' => $pluginParams['CLIENT_ID'],
    'button_size' => $pluginParams['BUTTON_SIZE'],
    'button_form' => $pluginParams['BUTTON_FORM'],
    'button_style' => $pluginParams['BUTTON_STYLE'],
    'web_to_app' => $pluginParams['USE_MWEB2APP'],
    'pkce' => $pluginParams['USE_PKCE'],
    'scopes' => isset($pluginParams['SCOPES']) ? $pluginParams['SCOPES'] : array(),
    'button_personal' => $pluginParams['BUTTON_PERSONAL'],
    'button_fast' => $pluginParams['BUTTON_FAST'],
  );
  if($pluginParams['API_MODE'] === 'TEST') {
      $options['client_id'] = $pluginParams['TEST_CLIENT_ID'];
  } else {
      $options['client_id'] = $pluginParams['CLIENT_ID'];

  }
  function checkScopes($scopes) {
    $res_scopes = 'openid+name+email';
    foreach ($scopes as $value) {
        if($value == 'openid' || $value == 'name' || $value == 'email') {
          continue;
        }
        $res_scopes .= '+' . $value;
    }
    return $res_scopes;
  }
  $sber_id_handler =  new Sberbank\Auth\handler('v5',$pluginParams['API_MODE']);

  $sber_id_handler->setClientId($options['client_id']);
  $sber_id_handler->setProperty('pkce', $options['pkce'] == 1 ? true : false);
  $sber_id_handler->setProperty('scope', checkScopes($options['scopes']));
  
  $sberbank_id_url = $sber_id_handler->generate_oauth_url();
  
  $sberbank_auth_params = $sber_id_handler->get_oauth_params();
  if($options['pkce'] == 1) {
    $session->set('sberid_code_verifier',  $sber_id_handler->getProperty('code_verifier'));
  }
  
  $sberbank_auth_params['notification'] = $pluginParams['NOTIFICATION'];
  $sberbank_auth_params['notification_theme'] = $pluginParams['NOTIFICATION_THEME'];
  $sberbank_auth_params['notification_position'] = $pluginParams['NOTIFICATION_POSITION'];

  // include template and assets
  $doc = JFactory::getDocument();
  $doc->addScript(JUri::root(true) . '/' . 'modules/mod_sber_id/js/sber_id_sdk.js?v=3');
  $doc->addStylesheet(JUri::root(true) . '/' . 'modules/mod_sber_id/css/sber_id.css?v=3');
  require JModuleHelper::getLayoutPath('mod_sber_id', $params->get('layout', 'default'));
}
